SystemOrganization addCategory: #'Pier-JQuery-Widgets'!

!GRPackage class methodsFor: '*pier-jquery' stamp: 'lr 10/7/2010 17:01'!
pierJQuery
	^ self new
		name: 'Pier-JQuery';
		description: 'JQuery support for Pier';
		addDependency: 'Pier-Seaside';
		addDependency: 'JQuery-UI';
		url: #pierAddonsUrl;
		yourself! !

PRStructuresWidget subclass: #PRAjaxSearchWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQuery-Widgets'!

!PRAjaxSearchWidget class methodsFor: 'accessing-defaults' stamp: 'lr 10/7/2010 15:36'!
defaultMaxItems
	^ 10! !

!PRAjaxSearchWidget class methodsFor: 'accessing-description' stamp: 'lr 9/12/2009 12:49'!
descriptionDropdownList
	^ nil! !

!PRAjaxSearchWidget class methodsFor: 'accessing-description' stamp: 'lr 10/7/2010 15:37'!
descriptionExampleText
	^ MAStringDescription new
		accessor: #exampleText;
		default: 'Search';
		label: 'Example';
		priority: 400;
		yourself! !

!PRAjaxSearchWidget class methodsFor: 'accessing-description' stamp: 'lr 10/7/2010 15:42'!
descriptionStructure
	^ PRStructureDescription new
		accessor: #structure;
		label: 'Search From';
		priority: 390;
		yourself! !

!PRAjaxSearchWidget class methodsFor: 'accessing' stamp: 'lr 9/12/2009 12:49'!
groupLabel
	^ 'Pier Search'! !

!PRAjaxSearchWidget class methodsFor: 'testing' stamp: 'lr 9/12/2009 12:49'!
isAbstract
	^ false! !

!PRAjaxSearchWidget class methodsFor: 'accessing' stamp: 'lr 10/7/2010 13:24'!
label
	^ 'Search Field (jQuery)'! !

!PRAjaxSearchWidget methodsFor: 'accessing' stamp: 'lr 9/12/2009 12:49'!
dropdownList
	^ false! !

!PRAjaxSearchWidget methodsFor: 'accessing-convenience' stamp: 'NickAger 11/14/2010 22:42'!
exampleText
	^ self read: #descriptionExampleText! !

!PRAjaxSearchWidget methodsFor: 'accessing-convenience' stamp: 'NickAger 11/14/2010 22:42'!
exampleText: exampleText
	self write:exampleText using: self class descriptionExampleText! !

!PRAjaxSearchWidget methodsFor: 'rendering' stamp: 'NickAger 11/14/2010 22:42'!
renderContentOn: html
	html textInput
		script: (html jQuery this autocomplete
			search: [ :value | self structuresFor: value ]
			labels: [ :value | value menu ]
			callback: [ :value :script |
				script goto: ((self context
					structure: value) 
					urlOn: html) ]);
		script: (html jQuery this example: self exampleText class: 'PRAjaxSearchWidgetExampleTextCss')! !

!PRAjaxSearchWidget methodsFor: 'accessing-convenience' stamp: 'NickAger 11/14/2010 22:42'!
structure
	"Answer the structure from where the widget should begin it's recursive search"
	^ (self read: #descriptionStructure) ifNil: [ self context root ]! !

!PRAjaxSearchWidget methodsFor: 'accessing-convenience' stamp: 'NickAger 11/14/2010 22:42'!
structure: aStructure
	self write: aStructure using: self class descriptionStructure! !

!PRAjaxSearchWidget methodsFor: 'private' stamp: 'NickAger 11/14/2010 22:41'!
structuresFor: aString
	| matches |
	matches := (self structure fullTextSearch subString: aString)
		reject: [ :each | self isFiltered: each ].
	self maxItems isNil
		ifFalse: [ matches := matches first: (matches size min: self maxItems) ].
	^ matches sorted: [ :a :b | (self labelFor: a) <= (self labelFor: b) ]! !

!PRAjaxSearchWidget methodsFor: 'updating' stamp: 'NickAger 11/14/2010 22:38'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.	 
			
	"assume that jQuery libraries are already loaded"
	anHtmlRoot javascript url: JQWidgetBoxDeploymentLibrary / #jqueryexampleminJs.
	anHtmlRoot stylesheet add: '.PRAjaxSearchWidgetExampleTextCss {color: gray;}'! !

!PRValueLink methodsFor: '*pier-jquery' stamp: 'lr 10/7/2010 14:46'!
jqAccordionIn: aContext
	<value: 'jq-accordion' comment: 'Display children of the current structure as an accordion.'>
	
	^ self lookupStructure: aContext structure do: [ :structure | [ :html |
		html div
			script: (html jQuery new accordion);
			with: [
				(aContext enumeratorFor: structure) do: [ :child |
					html div: child menu.
					html div: [
						html rendererInstance 
							visit: child ] ] ] ] ]! !

!PRValueLink methodsFor: '*pier-jquery' stamp: 'lr 10/7/2010 14:44'!
jqDialogIn: aContext
	<value: 'jq-dialog' comment: 'Display the structure within a modal dialog.'>
	
	^ self lookupStructure: aContext structure do: [ :structure | [ :html |
		| id |
		html span
			id: (id := html nextId);
			script: (html jQuery new dialog
				html: [ :renderer | 
					html rendererInstance 
						renderer: renderer;
						visit: structure ];
				title: structure title;
				modal: true).
		html anchor
			goto: (aContext structure: structure);
			onClick: ((html jQuery id: id) dialog open return: false);
			with: (self formatDescribed: structure default: #title) ] ]! !

!PRValueLink methodsFor: '*pier-jquery' stamp: 'lr 10/7/2010 14:46'!
jqTabsIn: aContext
	<value: 'jq-tabs' comment: 'Display children of the current structure as a tabbed widget.'>
	
	^ self lookupStructure: aContext structure do: [ :structure | [ :html |
		html div
			script: (html jQuery new tabs
				selected: (self propertyAt: 'selected' ifAbsent: [ 0 ]);
				yourself);
			with: [
				html unorderedList: [
					(aContext enumeratorFor: structure) do: [ :child |
						html listItem: [
							html anchor
								url: (html jQuery ajax
									html: [ :renderer | 
										html rendererInstance 
											renderer: renderer;
											visit: child ];
									fullUrl);
								with: child menu ] ] ] ] ] ]! !

PRWidget subclass: #PQCyclerWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQuery-Widgets'!

!PQCyclerWidget commentStamp: 'TudorGirba 8/16/2011 16:03' prior: 0!
PQCycler offers the JQuery Cycle plugin. It takes a source structure as an input and it creates a slideshow from its children.!

!PQCyclerWidget class methodsFor: 'accessing' stamp: 'TudorGirba 8/16/2011 20:01'!
descriptionDelay
	^ MANumberDescription new
		comment: 'Initial delay';
		parameterName: 'delay';
		accessor: #delay;
		label: 'Delay';
		priority: 130;
		default: 4000;
		bePositive;
		beInteger;
		yourself! !

!PQCyclerWidget class methodsFor: 'accessing' stamp: 'TudorGirba 8/22/2011 18:25'!
descriptionSource
	^ PRStructureDescription new
		label: 'Select a structure as source';
		parameterName: 'source';
		accessor: #source;
		label: 'Source';
		priority: 100;
		yourself! !

!PQCyclerWidget class methodsFor: 'accessing' stamp: 'TudorGirba 8/16/2011 20:00'!
descriptionSpeed
	^ MANumberDescription new
		comment: 'Transition speed';
		parameterName: 'speed';
		accessor: #speed;
		label: 'Speed';
		priority: 150;
		default: 1000;
		bePositive;
		beInteger;
		yourself! !

!PQCyclerWidget class methodsFor: 'accessing' stamp: 'TudorGirba 8/16/2011 19:56'!
descriptionTimeout
	^ MANumberDescription new
		comment: 'Timeout';
		parameterName: 'timeout';
		accessor: #timeout;
		label: 'Timeout';
		priority: 120;
		default: 3000;
		bePositive;
		beInteger;
		yourself! !

!PQCyclerWidget class methodsFor: 'accessing' stamp: 'TudorGirba 8/16/2011 16:01'!
groupLabel
	^ 'Pier JQuery-based Widget'! !

!PQCyclerWidget class methodsFor: 'testing' stamp: 'TudorGirba 8/16/2011 14:13'!
isAbstract
	^ false! !

!PQCyclerWidget class methodsFor: 'accessing' stamp: 'TudorGirba 8/16/2011 14:46'!
label
	^ 'Cycler'! !

!PQCyclerWidget methodsFor: 'accessing' stamp: 'TudorGirba 8/22/2011 18:37'!
children
	^ self sourceChildren 
		inject: OrderedCollection new 
		into: [:all :each | all addAll: (each componentsIn: self context). all]! !

!PQCyclerWidget methodsFor: 'accessing' stamp: 'TudorGirba 8/16/2011 19:59'!
delay
	^ self read: #descriptionDelay! !

!PQCyclerWidget methodsFor: 'rendering' stamp: 'TudorGirba 8/20/2011 13:06'!
renderContentOn: html
	self source isNil
		ifTrue: [ ^ html div: '(no source structure specified)' ].
	self sourceChildren isEmpty
		ifTrue: [ ^ html div: '(no children in the source structure available)' ].
	html div
		id: #cycler;
		script:
				((html jQuery: #cycler) cycle
						fx: 'fade';
						timeout: self timeout;
						delay: self delay;
						speed: self speed;
						pager: '#cyclerNav') greaseString;
		with: [ 
					self sourceChildren
						do: [ :each | 
							html div
								class: 'cyclerItem';
								with: [ self renderViewOf: each on: html ] ] ].
	html div
		id: #cyclerNav! !

!PQCyclerWidget methodsFor: 'rendering' stamp: 'TudorGirba 8/19/2011 07:42'!
renderViewOf: each on: html
	^ html rendererInstance withinContentDo: [ html rendererInstance continue: each document in: self on: html ]! !

!PQCyclerWidget methodsFor: 'accessing' stamp: 'TudorGirba 8/16/2011 15:15'!
source
	^ self read: #descriptionSource! !

!PQCyclerWidget methodsFor: 'updating' stamp: 'TudorGirba 8/20/2011 12:41'!
sourceChildren
	^ self source isNil
		ifTrue: [ #() ]
		ifFalse: [ self source enumerator contents ]! !

!PQCyclerWidget methodsFor: 'accessing' stamp: 'TudorGirba 8/16/2011 19:57'!
speed
	^ self read: #descriptionSpeed! !

!PQCyclerWidget methodsFor: 'accessing' stamp: 'TudorGirba 8/16/2011 19:57'!
timeout
	^ self read: #descriptionTimeout! !

!PQCyclerWidget methodsFor: 'updating' stamp: 'TudorGirba 8/16/2011 16:06'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.	 
			
	"assume that jQuery libraries are already loaded"
	anHtmlRoot javascript url: JQWidgetBoxDeploymentLibrary / #jquerycycleallJs! !
